package Adapter;

import java.rmi.*;
import java.rmi.activation.*;

public class MeinNichtRemoteKlasseAdapter implements NochEinRemoteInterface {

    private String resultat = null;
    private MeineNichtRemoteKlasse mnrk;

    // Konstruktor fr Aktivierung und Export; dieser Konstruktor
    // wird von der Aktivierungsmethode ActivationInstantiator.newInstance
    // whrend der Aktivierung aufgerufen, um das Objekt zu konstruieren.
    //
    public MeinNichtRemoteKlasseAdapter(ActivationID id, MarshalledObject data)
        throws RemoteException {

        // Registrieren des Objekts beim Aktivierungssystem
        // und EXport an einen anonymen Port
        //
        System.out.println("Adapter: Aufruf des Aktivierungskonstruktors");
        Activatable.exportObject(this, id, 0);
        System.out.println("Adapter: Aktivierungskonstruktors - Objekt wurde exportiert");
        try {
          System.out.println("Adapter: Aktivierungskonstruktors - ClientHost="+Activatable.getClientHost() );
        } catch(java.rmi.server.ServerNotActiveException snae)
        {
          System.out.println("Adapter: Aktivierungskonstruktors - ClientHost wurde nicht gefunden!");
        }

        // Instanz der Klasse 'MeineNichtRemoteKlasse' kreieren
	//
        mnrk = new MeineNichtRemoteKlasse();
        System.out.println("Adapter: Aktivierungskonstruktors - Instanz="+mnrk.toString());
    }

    // Definieren der Methoden aus dem Interface NochEinRemoteInterface
    // Diese akzeptiert eine Zeichenkette, modifiziert sie und
    // liefert die modifizierte dem Client zurck
    //
    public String rufDenServer(String strAdapterZeichenkette) throws RemoteException {

	// Hier wird die Zeichenkette nicht modifiziert:
	// statt sie zu modifizieren, wird sie an die
        // Implementation in der Klasse 'MeineNichtRemoteKlasse'
        // weitergegeben, dort bearbeitet und zurck geliefert.
	//
        resultat = mnrk.rufDenServer(strAdapterZeichenkette);
        System.out.println("Adapter: rufDenServer() Eingabe="+strAdapterZeichenkette);
        System.out.println("Adapter: rufDenServer() Rueckgabe="+resultat);
        return resultat;
    }
}
