package Beispiel1;

import java.rmi.*;
import java.rmi.activation.*;
import java.util.Properties;

public class Setup {

    // Diese Klasse registriert Informationen ber die ActivatableImplementation
    // Klasse mit Hilfe von rmid und der rmiregistry
    //
    public static void main(String[] args) throws Exception {
        System.out.println("Setup: Start");

        System.out.println("Setup: Setzen des Security Managers");
	System.setSecurityManager(new RMISecurityManager());

        // Ab Java 2 muss eine Security Policy definiert werden
        // fr die ActivationGroup VM
        // Das erste Argument von "put" ist der Schlssel (aus der
        // Hashtabelle),
        // das zweite Argument ist dessen Wert, der Dateiname
        //
 	Properties props = new Properties();
        System.out.println("Setup: Setzen der Property 'java.security.policy'");
        props.put("java.security.policy",
	    "java.policy");

        System.out.println("Setup: ActivationGroup");
        ActivationGroupDesc.CommandEnvironment ace = null;
 	ActivationGroupDesc beispielGruppe = new ActivationGroupDesc(props, ace);

	// Registrieren der ActivationGroupDesc
	// Dies liefert eine ID
	//
        ActivationGroupID agi =
           ActivationGroup.getSystem().registerGroup(beispielGruppe);

	// kreieren der Gruppe
	//
	ActivationGroup.createGroup(agi, beispielGruppe, 0);

	// die Zeichenkette "location" spezifiziert eine URL
        // von der die Klassendefinition geladen werden kann
        // falls das Objekt aktiviert werden muss.
        // Am Schluss der URL
        // steht ein "/".
        //
	String location = "file:/D:/UnterrichtsUnterlagen/ParalleleUndVerteilteSysteme/Kapitel17_RMInvocation/Programme/Aktivierung/";
        System.out.println("Setup: Lokation (URL) - "+location);

	// kreieren des Rests der Parameter
	// fr den ActivationDesc Konstruktor
	//
	MarshalledObject data = null;

	// Das zweite Argument des ActivationDesc Konstruktors wird bentigt,
	// um diese Klasse eindeutig zu identifizieren;
        // die Lokation bezieht sich relativ auf die
	// URL-formatierte Zeichenkette "location".
	//
	ActivationDesc desc = new ActivationDesc
	    ("Beispiel1.ActivatableImplementation", location, data);

	// Registrieren bei rmid
	//
	MeinRemoteInterface mri = (MeinRemoteInterface)Activatable.register(desc);
        System.out.println("Setup: der Stub fuer die ActivatableImplementation wurde gefunden" );

	// Binden des Stub an einen Namen in der Registry an Port 1099
	//
	Naming.rebind("ActivatableImplementation", mri);
        System.out.println("Setup: die ActivatableImplementation wurde exportiert" );
        System.out.println("Setup: Ende");
	System.exit(0);
    }
}
