package Beispiel2;

import java.rmi.*;

public class Client2 {

    public static void main(String args[]) {
        System.out.println("Client: Start");
	String server = "localhost";
	if (args.length < 1) {
	    System.out.println ("Usage: java Client <rmihost>");
     	    System.out.println ("       Standard: java Client localhost");
	    //System.exit(1);
	} else {
	    server = args[0];
	}

	// Setzen eines Security Manager, damit der Client
	// den aktivierbaren Stub des Objekts heruntergeladen werden knnen.
	//
        System.out.println("Client: setzen des SecurityManagers");
	System.setSecurityManager(new RMISecurityManager());

	try {

	    String location = "rmi://" + server + "/MeinRemoteInterfaceImpl";
	    // Da mein keine Instanz eines Interfaces kreieren kann,
     	    // erhalten wir beim Lookup eine remote Referenz auf ein Objekt
	    // welches MeinRemoteInterface implementiert.
	    //
	    // Diese remote Referenz von Naming.lookup(...) casten wir dann
            // (serialisierte Stub Instanz)
	    // zu einem "MeinRemoteInterface", damit wir die Methoden des
	    // Interfaces einsetzen knnen.
            //
            System.out.println("Client: Lookup");
	    MeinRemoteInterface mri = (MeinRemoteInterface)Naming.lookup(location);
	    System.out.println("Client: remote Referenz auf ein Objekt,"+
		" welches Activatable implementiert.");

	    // Die Zeichenkette "Resultat" wird vom remote Methodenaufruf
            // in eine andere Zeichenkette umgewandelt
	    //
	    String result = "Client: Fehlschlag";
	    System.out.println("Client: Aufruf der remote Methode auf dem Server");

	    result = (String)mri.rufMichRemoteAuf();
	    System.out.println("Client: Result des Aufrufs - " + result);

	} catch (Exception e) {
		System.out.println("Client: Exception: " + e);
		e.printStackTrace();
	}
    }
}

