package Beispiel2;

import java.rmi.*;
import java.rmi.activation.*;
import java.util.Properties;

public class Setup2 {

    // Diese Klasse registriert Informationen ber
    // MeinRemoteInterfaceImpl bei rmid und rmiregistry
    //
    public static void main(String[] args) throws Exception {
        System.out.println("Setup2: Start");

        System.out.println("Setup2: Setzen des Security Managers");
	System.setSecurityManager(new RMISecurityManager());

        // Ab Java 2 muss eine Security Policy definiert werden
        // fr die ActivationGroup VM
        // Das erste Argument von "put" ist der Schlssel (aus der
        // Hashtabelle),
        // das zweite Argument ist dessen Wert, der Dateiname
        //
        System.out.println("Setup2: Setzen der Property 'java.security.policy'");
	Properties props = new Properties();
        props.put("java.security.policy",
	    "java.policy");

        System.out.println("Setup2: ActivationGroup");
	ActivationGroupDesc.CommandEnvironment ace = null;
	ActivationGroupDesc beispielGruppe = new ActivationGroupDesc(props, ace);

	// Registrieren der ActivationGroupDesc
	// Dies liefert eine ID
	//
	ActivationGroupID agi =
	   ActivationGroup.getSystem().registerGroup(beispielGruppe);
	// kreieren der Gruppe
	//
	ActivationGroup.createGroup(agi, beispielGruppe, 0);
	// die Zeichenkette "location" spezifiziert eine URL
        // von der die Klassendefinition geladen werden kann
        // falls das Objekt aktiviert werden muss.
        // Am Schluss der URL
        // steht ein /.
        //
	String location = "file:/D:/UnterrichtsUnterlagen/ParalleleUndVerteilteSysteme/Kapitel17_RMInvocation/Programme/Aktivierung/";
        System.out.println("Setup2: Lokation (URL) - "+location);

	// kreieren des Rests der Parameter
	// fr den ActivationDesc Konstruktor
	//
	MarshalledObject data = null;
	// Das zweite Argument des ActivationDesc Konstruktors wird bentigt,
	// um diese Klasse eindeutig zu identifizieren;
        // die Lokation bezieht sich relativ auf die
	// URL-formatierte Zeichenkette "location".
	//
        System.out.println("Setup2: ActivationDesc");
	ActivationDesc desc = new ActivationDesc(
              "Beispiel2.ActivatableImplementation", location, data);

        System.out.println("Setup2: Casting");
	MeinRemoteInterface mri = (MeinRemoteInterface)Activatable.register(desc);
        System.out.println("Setup2: der Stub fuer die ActivatableImplementation wurde gefunden" );
	// Registrieren bei rmid
	//
	Naming.rebind("MeinRemoteInterfaceImpl", mri);
        System.out.println("Setup2: die ActivatableImplementation wurde exportiert" );
        System.out.println("Setup2: Ende");
	System.exit(0);
    }
}

