package Beispiel3;

import java.rmi.*;

public class Client3 {

    public static void main(String args[]) {

	String server = "localhost";
	if (args.length < 1) {
	    System.out.println ("Usage: java Client <rmihost>");
	    // System.exit(1);
            // server ist 'localhost'
	} else {
	    server = args[0];
	}

	// Setzen eines Security Manager, damit der Client
	// den aktivierbaren Stub des Objekts heruntergeladen werden knnen.
	//

        System.out.println("Client: setzen des SecurityManagers");
	System.setSecurityManager(new RMISecurityManager());

	try {
          String location = "rmi://" + server + "/MeineKlasse";

          // Da mein Client keine Instanz eines Interfaces kreieren kann,
     	  // erhalten wir beim Lookup eine remote Referenz auf ein Objekt
	  // welches MeinRemoteInterface implementiert.
	  //
	  // Diese remote Referenz von Naming.lookup(...) casten wir dann
          // (serialisierte Stub Instanz)
	  // zu einem "MeinRemoteInterface", damit wir die Methoden des
	  // Interfaces einsetzen knnen.
          //

          System.out.println("Client: Lookup");
	  NochEinRemoteInterface neri =
		(NochEinRemoteInterface)Naming.lookup(location);

          System.out.println("Client: remote Referenz auf ein Objekt,");
          System.out.println("        welches Activatable implementiert.");
          System.out.println("        remoteRef="+neri.toString() );

	  // der remote Methodenaufruf ergnzt die Zeichenkette 'resultat'
	  //
	  String resultat = "Harry Potter bist Du hier? ";

          System.out.println("Client: Aufruf der remote Methode 'rufDenServer("+resultat+")';");
	  resultat = (String)neri.rufDenServer(resultat);
          System.out.println("Client: Ergebnis des Aufrufs");
          System.out.println("        "+resultat);

	} catch (Exception e) {
	  System.out.println("Client: Eine Exception wurde geworfen: " + e);
	  e.printStackTrace();
	}
    }
}