package MarshalledObjectPersistenz;

import java.rmi.*;
import java.util.Vector;

public class Client {

    public static void main(String args[]) {

	String server = "localhost";
	if (args.length < 1) {
	    System.out.println ("Usage: java Client <rmihost>");
	    //System.exit(1);
            // Default: localhost
	} else {
	    server = args[0];
	}

	// Setzen eines Security Manager, damit der Client
	// den aktivierbaren Stub des Objekts heruntergeladen werden knnen.
	//
        System.out.println("Client: setzen des SecurityManagers");
	System.setSecurityManager(new RMISecurityManager());

	try {

	    String location = "rmi://" + server + "/MeinePersistenteKlasse";

          // Da mein Client keine Instanz eines Interfaces kreieren kann,
     	  // erhalten wir beim Lookup eine remote Referenz auf ein Objekt
	  // welches MeinRemoteInterface implementiert.
	  //
	  // Diese remote Referenz von Naming.lookup(...) casten wir dann
          // (serialisierte Stub Instanz)
	  // zu einem "MeinRemoteInterface", damit wir die Methoden des
	  // Interfaces einsetzen knnen.
          //

          System.out.println("Client: Lookup");
          RemoteInterface ri =
		(RemoteInterface)Naming.lookup(location);
          System.out.println("Client: remote Referenz auf ein Objekt,");
          System.out.println("        welches Activatable implementiert.");
          System.out.println("        remoteRef="+ri.toString() );

	  // der remote Methodenaufruf ergnzt die Zeichenkette 'resultat'
	  //
          System.out.println("Client: Aufbau des Resultat Vektors");
          Vector resultat = new Vector (1,5);
	  resultat.addElement("Betrag einzahlen");
	  resultat.addElement("Betrag abheben");
	  resultat.addElement("Transferierter Betrag");
	  resultat.addElement("Eingezogener Check");
	  resultat.addElement("Einkauf im CooP");

          System.out.println("Client: Aufruf der remote Methode 'rufDenServer()'");
	  resultat = (Vector)ri.rufDenServer(resultat);
	  System.out.println("Client: Resultat: ");
	  for (int i = 0; i < resultat.size(); i++) {
	    System.out.println("Client: Ergebnis "+i+" "+ resultat.elementAt(i));
          }

	} catch (Exception e) {
		System.out.println("Client: Exception: " + e);
		e.printStackTrace();
	}
    }
}

