package MarshalledObjectPersistenz;

import java.io.File;
import java.rmi.*;
import java.rmi.activation.*;
import java.util.Properties;

public class Setup {

    // Diese Klasse registriert Informationen ber 'MeinePersistenzKlasse'
    // bei der RMI Registry und dem RMI Daemon
    //
    public static void main(String[] args) throws Exception {
        System.out.println("Setup: Start");
	System.setSecurityManager(new RMISecurityManager());
        System.out.println("Setup: Setzen des Security Managers");
        // Ab Java 2 muss eine Security Policy definiert werden
        // fr die ActivationGroup VM
        // Das erste Argument von "put" ist der Schlssel (aus der
        // Hashtabelle),
        // das zweite Argument ist dessen Wert, der Dateiname
        //
	Properties props = new Properties();
        System.out.println("Setup: Setzen der Property 'java.security.policy'");
        props.put("java.security.policy", "java.policy");

        System.out.println("Setup: ActivationGroup");
        ActivationGroupDesc.CommandEnvironment ace = null;
 	ActivationGroupDesc beispielGruppe = new ActivationGroupDesc(props, ace);

	// Registrieren der ActivationGroupDesc
	// Dies liefert eine ID
	//
        ActivationGroupID agi =
           ActivationGroup.getSystem().registerGroup(beispielGruppe);

	// kreieren der Gruppe
	//
	ActivationGroup.createGroup(agi, beispielGruppe, 0);

	// die Zeichenkette "location" spezifiziert eine URL
        // von der die Klassendefinition geladen werden kann
        // falls das Objekt aktiviert werden muss.
        // Am Schluss der URL
        // steht ein "/".
        //
	String location = "file:/D:/UnterrichtsUnterlagen/ParalleleUndVerteilteSysteme/Kapitel17_RMI_Praxis/Programme/Aktivierung/MarshalledObjectPersistenz/";
        System.out.println("Setup: Lokation (URL) - "+location);

	// kreieren des Rests der Parameter
	// fr den ActivationDesc Konstruktor
	//
	// Angabe der Datei in der die Daten als Marshalled
	// Objekt gespeichert werden sollen
        System.out.println("Setup: MarshalledObject");
        String strTemp = "D:/UnterrichtsUnterlagen/ParalleleUndVerteilteSysteme/Kapitel17_RMI_Praxis/Programme/Aktivierung/MarshalledObjectPersistenz/persistentesObjekt.ser";
	MarshalledObject data =  new MarshalledObject (new File(strTemp));

	// Das zweite Argument des ActivationDesc Konstruktors wird bentigt,
	// um diese Klasse eindeutig zu identifizieren;
        // die Lokation bezieht sich relativ auf die
	// URL-formatierte Zeichenkette "location".
	//
        System.out.println("Setup: ActivationDesc");
	ActivationDesc desc = new ActivationDesc
	    ("MarshalledObjectPersistenz.MeinePersistenteKlasse", location, data);

	// Registrieren bei rmid
	//
	RemoteInterface ri =
	    (RemoteInterface)Activatable.register(desc);
        System.out.println("Setup: der Stub fuer die ActivatableImplementation wurde gefunden" );

	// Binden des Stub an einen Namen in der Registry an Port 1099
	//
	Naming.rebind("MeinePersistenteKlasse", ri);
        System.out.println("Setup: die ActivatableImplementation wurde exportiert" );
        System.out.println("Setup: Ende");
	System.exit(0);
    }
}
