
//Titel:        RMI Hello World Projekt
//Autor:       J.M.Joller
//Firma:      (C) J.M.Joller
//Beschreibung:  Applet und Server fr ein RMI Hello World Beispiel
package HelloWorld;

import java.rmi.*;
import java.net.*;
import java.rmi.server.UnicastRemoteObject;
public class HelloImpl extends UnicastRemoteObject implements Hello {
  private String name;
  public HelloImpl(String s) throws RemoteException {
    super();
    name = s;
  }
  public String sayHello() throws RemoteException {
    return "Hello World!";
  }
  public static void main(String args[]) {
    // kreieren und installieren eines Security Managers
    System.out.println("HelloWorld.main : Start");
    System.out.println("HelloWorld.main : Security");
    System.setSecurityManager(new RMISecurityManager());

    try {
      System.out.println("HelloWorld.main : Objektkonstruktion");
      HelloImpl obj = new HelloImpl("HelloServer");
      //Naming.rebind("//ztnw293.hta.fhz.ch/HelloServer", obj);
      System.out.println("HelloWorld.main : Binden");
      Naming.rebind("rmi://localhost:1099/HelloServer", obj);
      System.out.println("HelloServer in die Registry eingetragen!");
    } catch (Exception e) {
      System.out.println("HelloImpl err: " + e.getMessage());
      e.printStackTrace();
    }
    try {
      for (int i=0; i< Naming.list("rmi://localhost/").length; i++)
      System.out.println("RMI Registry Eintraege : "+Naming.list("//localhost/")[i]);
    } catch(RemoteException e) {}
      catch(MalformedURLException e) {}
    System.out.println("HelloImpl.main: Ende");
  }
}
