package HelloWorldBeispiel;

import java.applet.Applet;
import java.awt.Graphics;
import java.rmi.RemoteException;
//RMI: import java.rmi.Naming;
// RMI over IIOP:
import java.rmi.RMISecurityManager;
import javax.rmi.PortableRemoteObject;
import java.util.*;
import javax.naming.*;

public class HalloApplet extends Applet {

    String message = "Das ist aber unfreundlich - heute gibts kein Hallo!";

    // "obj" identifiziert das remote Objekt
    // welches das "Hallo"
    // Interface implementiert
    Hallo obj = null;
    public void init() {
	try {
            // RMI
	    /*obj = (Hallo)Naming.lookup("//" +
			 getCodeBase().getHost() + "/HalloServer");
            */
            // RMI over IIOP:
            // Kreieren und installieren eines Security Manager
            if (System.getSecurityManager() == null) {
                System.out.println("HalloServer: Setzen des Security Managers");
	        System.setSecurityManager(new RMISecurityManager());
            }

            // RMI over IIOP:
            // Kreieren des JNDI Context
            System.out.println("HalloApplet: Initialisierung");
            System.out.println("HalloApplet: initialNamingContext");
            Context initialNamingContext = new InitialContext();

            // RMI over IIOP
            System.out.println("HalloApplet: Hashtable");
            Hashtable env = new Hashtable();
            env.put("java.naming.corba.applet", this);
            //Die nchsten zwei Werte werden in Zukunft Applet Tags sein
            env.put("java.naming.factory.initial",
                  "com.sun.jndi.cosnaming.CNCtxFactory");
            env.put("java.naming.provider.url", "iiop://localhost:1050");
            System.out.println("HalloApplet: initialContext");
            Context ic = new InitialContext(env);

            // RMI over IIOP
            System.out.println("HalloApplet: casting des PortableRemoteObject");
            Hallo obj =
            (Hallo)PortableRemoteObject.narrow(
                              initialNamingContext.lookup("HalloServer"),
                              Hallo.class);
            System.out.println("HalloApplet: Aufruf der RemoteMethode");
	    message = obj.sagHallo();
            System.out.println("HalloApplet: Ende");
	} catch (Exception e) {
	    System.out.println("HalloApplet: Exception: " +
				    e.getMessage());
	    e.printStackTrace();
	}
    }

    public void paint(Graphics g) {
	g.drawString(message, 25, 50);
    }
}
