package HelloWorld;

import java.io.*;
import java.rmi.*;
import java.rmi.server.*;

public class HalloImpl extends UnicastRemoteObject implements Hallo {

    /*
     * Aufruf der Oberklasse mit dem Protokoll:
     * Client und Server Socket Factory.
     */
    public HalloImpl(String protocol, byte [] pattern) throws RemoteException {
	super(0, new MultiClientSocketFactory(protocol, pattern),
	      new MultiServerSocketFactory(protocol, pattern));
    }

    /*
     * Remote Methode, die einen String "Hallo Du da!"
     * zurck liefert, falls sie aufgerufen wird.
     */
    public String sagHallo() throws RemoteException {
        System.out.println("HalloServer: Methode sagHallo wurde aufgerufen!");
        return  "Hallo Du da!";
    }

    public static void main(String args[]) {
        System.out.println("HalloServer: Start");
	//Kreieren und installieren des Security Managers
	if (System.getSecurityManager() == null)
	    System.setSecurityManager(new RMISecurityManager());
        System.out.println("HalloServer: SecurityManager wurde installiert");
        byte [] aPattern = { (byte)1011 };
	try {
	    HalloImpl objXOR = new HalloImpl("xor", aPattern);
	    HalloImpl objCompression = new HalloImpl("compression", null);
	    Naming.rebind("/HalloXORServer", objXOR);
	    System.out.println("HalloXORServer: in die Registry gebunden");
	    Naming.rebind("/HalloCompressionServer", objXOR);
	    System.out.println("HalloCompressionServer: in die Registry gebunden");
	} catch (Exception e) {
	    System.out.println("HalloImpl err: " + e.getMessage());
	    e.printStackTrace();
	}
    }
}
