package HelloWorld;

import java.io.*;
import java.net.*;
import java.rmi.server.*;

public class MultiServerSocketFactory
    implements RMIServerSocketFactory, Serializable
{
    private static RMISocketFactory defaultFactory =
	RMISocketFactory.getDefaultSocketFactory();

    private String protocol;
    private byte [] data;

    public MultiServerSocketFactory(String protocol, byte [] data) {
	this.protocol = protocol;
	this.data = data;
    }

    public ServerSocket createServerSocket(int port) throws IOException
    {
	if (protocol.equals("compression")) {
            System.out.println("MultiServerSocketFactory: Es werden Compression Sockets verwendet");
	    return new CompressionServerSocket(port);

	} else if (protocol.equals("xor")) {
            System.out.println("MultiServerSocketFactory: Es werden XOR Sockets verwendet");
	    if (data == null || data.length != 1)
		throw new IOException("MultiServerSocketFactory: ungueltiges Argument fr das XOR Protokoll");
	    return new XorServerSocket(port, data[0]);
	}
        System.out.println("MultiServerSocketFactory: Es wird das Standard Socket Protokoll verwendet!");
	return defaultFactory.createServerSocket(port);
    }
}
