package HelloWorld;

import java.io.*;


class XorInputStream extends FilterInputStream {

   /*
    * Byte, mit dem Daten "verschlsselt" werden "decrypt".
    * Default ist 10101010.
    */
    private byte pattern = (byte)(170 & 0xFF);

    /*
     * Konstruktor fr die Klasse XorInputStream
     */
    public XorInputStream(InputStream in, byte pattern) {
        super(in);
	if (pattern != 0)
            this.pattern = pattern;
    }

    /*
     * Liest ein Byte und xor't das Byte mit dem Pattern.
     * Liefert das Byte zurck.
     */
    public int read() throws IOException {
        int b = in.read();
        //Falls nicht EOF oder Fehler: reduziere b auf ein Byte
	if (b != -1)
	  b = (b ^ pattern) & 0xFF;

	return b;
    }

    /*
     * Lesen von bis zu len Bytes
     */
    public int read(byte b[], int off, int len) throws IOException {
        int numBytes = in.read(b, off, len);

	if (numBytes <= 0)
	    return numBytes;

        int i = 0;
        for(; i < numBytes; i++) {
	    b[off + i] = (byte)((b[off + i] ^ pattern) & 0xFF);
        }
	return i;
    }
}
