package Komprimierung;

import java.io.*;
import java.net.*;

class CompressionSocket extends Socket {

    /* InputStream  */
    private InputStream in;
    /* OutputStream  */
    private OutputStream out;

    /*
     * Standard Konstruktor fr CompressionSocket
     */
    public CompressionSocket() { super(); }

    /*
     * Konstruktor fr CompressionSocket
     */
    public CompressionSocket(String host, int port) throws IOException {
        super(host, port);
    }

    /*
     * Rckgabe eines CompressionInputStream Stromes
     */
    public InputStream getInputStream() throws IOException {
        if (in == null) {
            in = new CompressionInputStream(super.getInputStream());
        }
        return in;
    }

    /*
     * Rckgabe eines CompressionOutputStream Stromes
     */
    public OutputStream getOutputStream() throws IOException {
        if (out == null) {
            out = new CompressionOutputStream(super.getOutputStream());
        }
        return out;
    }

    /*
     * Flush (leeren) des CompressionOutputStream vor
     * dem Schliessen des Socket.
     */
    public synchronized void close() throws IOException {
        OutputStream o = getOutputStream();
        o.flush();
	super.close();
    }
}
