package MultiSocket;

import java.io.*;
import java.net.*;
import java.rmi.server.*;

public class MultiClientSocketFactory
    implements RMIClientSocketFactory, Serializable
{
    /*
     * Standard RMISocketFactory
     */
    private static RMISocketFactory defaultFactory =
	RMISocketFactory.getDefaultSocketFactory();

    private String protocol;
    private byte[] data;

    public MultiClientSocketFactory(String protocol, byte[] data) {
	this.protocol = protocol;
	this.data = data;
    }
    /*
     * berschreiben der createSocket Methode der
     * RMISocketFactory Klasse.
     * Falls man weder "Compression" oder "XOR" angibt,
     * wird eine Standard TCP Connection aufgebaut.
     */
    public Socket createSocket(String host, int port)
	throws IOException
    {
	if (protocol.equals("compression")) {
	    return new CompressionSocket(host, port);
	} else if (protocol.equals("xor")) {
	    if (data == null || data.length != 1)
		throw new IOException("ungueltiges Argument fr das XOR Protokoll");
	    return new XorSocket(host, port, data[0]);
	}
	return defaultFactory.createSocket(host, port);
    }
}
