package MultiSocket;

import java.io.*;
import java.net.*;

class XorSocket extends Socket {

    /*
     * Pattern zum verschlsseln und entschlsseln:
     * alle Daten, die von / an den Socket gesandt werden.
     */
    private byte pattern;

    /* InputStream, der vom Socket verwendet wird. */
    private InputStream in = null;

    /* OutputStream, der vom Socket verwendet wird. */
    private OutputStream out = null;

    /*
     * Konstruktor fr die Klasse XorSocket.
     */
    public XorSocket(byte pattern)
        throws IOException
    {
        super();
        this.pattern = pattern;
    }

    /*
     * Konstruktor fr die Klasse XorSocket.
     */
    public XorSocket(String host, int port, byte pattern)
        throws IOException
    {
        super(host, port);
        this.pattern = pattern;
    }

    /*
     * Liefert einen Stream vom Typus XorInputStream.
     */
    public InputStream getInputStream() throws IOException {
        if (in == null) {
            in = new XorInputStream(super.getInputStream(), pattern);
        }
        return in;
    }

    /*
     *Liefert einen Stream vom Typus XorOutputStream.
     */
    public OutputStream getOutputStream() throws IOException {
        if (out == null) {
            out = new XorOutputStream(super.getOutputStream(), pattern);
        }
        return out;
    }
}
